/* DNS support routines
   BullDog Dynamic Firewall
   by Father Peter Darin

   Covered by GNU license
*/

/* Definitions */

#define DNSLIST                 "/sbin/bulldog/dns/"

/* General usage globals */

I  INDNSList(C *sp);

S
  {
    ip ip;
    dn resolved;
  } DNSList;

I INDNSList(C *sp)
  {
    dn d1, d2;
    I  fh1, i, lr, done=FALSE;

    dstrcopy(d1,sp);
    for(i=dstrlen(d1);d1[i]!='.';i--);
    d1[i]='\0';
    
    for(i=0;d1[i]!='\0';i++)   // Make into directories
      if(d1[i]=='.')
        d1[i]='/';

    sprintf(d2,"%s%s",DNSLIST,d1);

    fh1=sopen(d2,O_RDONLY,SH_DENYNO,S_IREAD);
    if(fh1>0)
      {
        lr=lseek(fh1,0,SEEK_END)/sizeof(DNSList);
        for(i=0;i<lr && done==FALSE;i++)
          {
            lseek(fh1,i*sizeof(DNSList),SEEK_SET);
            read(fh1,&DNSList,sizeof(DNSList));
    
            done=dstrcmp(sp,DNSList.ip);
          }
        close(fh1);
      }
    return(done);
  }

